#  Pattern_register.defn.tcl


set Pattern_registerBase 32   

proc {Add_Pattern Register_Module} {name server addressdata} {
   global CurrentVMEServer

   set moduleID [last [split $name #]]

#    split up address information into 
   set addressinfo [split $addressdata :]

   set A32addrbase [third $addressinfo]

   set CurrentVMEServer  $server
 

	define-vme-register $name xVME ModCont		"-a$A32addrbase -w32 -o0x0 -prw -d32 -zx"
	define-vme-register $name xVME ModStat		"-a$A32addrbase -w32 -o0x4 -pro -d32 -zx"
	define-vme-register $name xVME IntrCont		"-a$A32addrbase -w32 -o0x8 -prw -d32 -zx"
	define-vme-register $name xVME IntrSelct	"-a$A32addrbase -w32 -o0xC -prw -d32 -zx"
	define-vme-register $name xVME FifoRd		"-a$A32addrbase -w32 -o0x10 -pro -d32 -zx"
	define-vme-register $name xVME Tracks		"-a$A32addrbase -w32 -o0x14 -pro -d32 -zx"
	define-vme-register $name xVME FifoFlags	"-a$A32addrbase -w32 -o0x18 -pro -d32 -zx"
	define-vme-register $name xVME GrpABdel		"-a$A32addrbase -w32 -o0x114 -prw -d32 -zd"
	define-vme-register $name xVME GrpAEnb		"-a$A32addrbase -w32 -o0x10C -prw -d32 -zx"
	define-vme-register $name xVME GrpAInv		"-a$A32addrbase -w32 -o0x108 -prw -d32 -zx"
	define-vme-register $name xVME GrpAStr		"-a$A32addrbase -w32 -o0x110 -prw -d32 -zd"
	define-vme-register $name xVME GrpAMode		"-a$A32addrbase -w32 -o0x100 -prw -d32 -zd -l4 -b0"
	define-vme-register $name xVME GrpAInvB		"-a$A32addrbase -w32 -o0x100 -prw -d32 -zd -l1 -b4"
	define-vme-register $name xVME GrpBEnb		"-a$A32addrbase -w32 -o0x20C -prw -d32 -zx"
	define-vme-register $name xVME GrpBInv		"-a$A32addrbase -w32 -o0x208 -prw -d32 -zx"
	define-vme-register $name xVME GrpBMode		"-a$A32addrbase -w32 -o0x200 -prw -d32 -zd"
	define-vme-register $name xVME Insp0		"-a$A32addrbase -w32 -o0x300 -prw -d32 -zx"
	define-vme-register $name xVME Insp1		"-a$A32addrbase -w32 -o0x304 -prw -d32 -zx"
	define-vme-register $name xVME Insp2		"-a$A32addrbase -w32 -o0x308 -prw -d32 -zx"
	define-vme-register $name xVME Insp3		"-a$A32addrbase -w32 -o0x30C -prw -d32 -zx"
	define-vme-register $name xVME InpCont		"-a$A32addrbase -w32 -o0x400 -prw -d32 -zx"

	define-vme-register $name xVME IntFifo.TimeLS	"-a$A32addrbase -w32 -o0x500 -pro -d32 -zx"
	define-vme-register $name xVME IntFifo.TimeMS	"-a$A32addrbase -w32 -o0x504 -pro -d32 -zx"
	define-vme-register $name xVME IntFifo.TimeCnt	"-a$A32addrbase -w32 -o0x508 -pro -d32 -zx"
	define-vme-register $name xVME IntFifo.GrpA	"-a$A32addrbase -w32 -o0x510 -pro -d32 -zx"
	define-vme-register $name xVME IntFifo.GrpACnt	"-a$A32addrbase -w32 -o0x518 -pro -d32 -zx"
	define-vme-register $name xVME IntFifo.GrpB	"-a$A32addrbase -w32 -o0x520 -pro -d32 -zx"
	define-vme-register $name xVME IntFifo.GrpBCnt	"-a$A32addrbase -w32 -o0x528 -pro -d32 -zx"
	define-vme-register $name xVME IntFifo.Type	"-a$A32addrbase -w32 -o0x530 -pro -d32 -zx"
	define-vme-register $name xVME IntFifo.TypeCnt	"-a$A32addrbase -w32 -o0x538 -pro -d32 -zx"
	define-vme-register $name xVME IntFifo.Flags	"-a$A32addrbase -w32 -o0x560 -pro -d32 -zx"

	define-vme-register $name xVME GrpA		"-a$A32addrbase -w32 -o0x540 -prw -d32 -zx"
	define-vme-register $name xVME GrpB		"-a$A32addrbase -w32 -o0x544 -prw -d32 -zx"
	define-vme-register $name xVME Sync		"-a$A32addrbase -w32 -o0x548 -prw -d32 -zx"
	define-vme-register $name xVME Pause		"-a$A32addrbase -w32 -o0x54C -prw -d32 -zx"
	define-vme-register $name xVME Resume		"-a$A32addrbase -w32 -o0x550 -prw -d32 -zx"
	define-vme-register $name xVME Undefined	"-a$A32addrbase -w32 -o0x554 -prw -d32 -zx"

	define-vme-register $name xVME FifoWrt		"-a$A32addrbase -w32 -o0x558 -pwo -d32 -zx"
	define-vme-register $name xVME InpFifoFlags	"-a$A32addrbase -w32 -o0x560 -pro -d32 -zx"
	define-vme-register $name xVME LoadTime		"-a$A32addrbase -w32 -o0x600 -pwo -d32 -zx"

   define-vme-register PatternRegister generic Insp0Use "-nPatternRegister_Insp0Use -tstring"
   define-vme-register PatternRegister generic Insp1Use "-nPatternRegister_Insp1Use -tstring"
   define-vme-register PatternRegister generic Insp2Use "-nPatternRegister_Insp2Use -tstring"
   define-vme-register PatternRegister generic Insp3Use "-nPatternRegister_Insp3Use -tstring"

}


proc {Pattern Register_DAQ-reset} {args} {
#   
    global CurrentVMEServer EGallow EGreport
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]

#      perform simple module access - if a bus error occurs then generate warning
    set EGallow 0x2000a
    if {[read-vme-register $module.ModStat] == $EGallow} then {bus-error $module; set EGallow 0xffffffff; return}
    set EGallow 0xffffffff
}

# N.B. go is the same as halt!

# go sets MasterCounterEnable only which starts the card going for
# synchronisation etc but hasn't set RunEnable so it doesn't output data
# i.e it's going

# halt sets MasterCounterEnable only which clears RunEnable
# so it doesn't output data
# i.e it's halted

# Obvious really

# (RunEnable, which allows data to be output, is set in custom_PostGo)

proc {Pattern Register_DAQ-go} {args} { 
#   This routine sets the MasterCounterEnable bit for each called card
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.InpCont 0x2
}

proc {Pattern Register_DAQ-halt} {args} {
#   This routine sets the MasterCounterEnable bit for each called card
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.InpCont 0x2
}

proc {Pattern Register_DAQ-setup} {args} {
#   
    global CurrentVMEServer Pattern_registerBase
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    set i [second [split $module #]]

# Patrick 21/12/04 
# modified to change this from 0x22 to 0x02. The run-enable shouldn't be set I think here 

    write-vme-register $module.InpCont 0x02	;# no data throughput
    write-vme-register $module.ModCont 4        ;# FIFO reset
    write-vme-register $module.ModCont 0xA	;# starx_enable, and sharc_enable

     set modnum [expr $Pattern_registerBase + $i - 1]
    
    	write-vme-register $module.GrpA 	[expr 0xc0000000 + ( $modnum << 21 ) ]
	write-vme-register $module.GrpB 	[expr 0xc0010000 + ( $modnum << 21 ) ]

	write-vme-register $module.Sync 	[expr 0x80400000 + ( $modnum << 24 ) ]
	write-vme-register $module.Pause  	[expr 0x80200000 + ( $modnum << 24 ) ]	
	write-vme-register $module.Resume  	[expr 0x80300000 + ( $modnum << 24 ) ]	
	write-vme-register $module.Undefined 	[expr 0x80000000 + ( $modnum << 24 ) ]
}

proc {Pattern Register_DAQ-custom_PostGo} {args} {
#   This routine sets the RunEnable (and MasterCounterEnable) bit(s) for each called card
    global CurrentVMEServer
    set server [second $args]
    if {$server != ""} then {set CurrentVMEServer $server}
    set module [first $args]
    write-vme-register $module.InpCont 0x22
}

#   for parameter save/restore
set {Pattern Register_registersavepatterns} {GrpAEnb GrpAInv GrpAMode GrpAStr GrpABdel GrpAInvB GrpBEnb GrpBInv GrpBMode}
