set MPXPresent 1
if {[info exists env(MPXServer)]} then {set MPXServer $env(MPXServer)} \
    else {set MPXServer vme}
    
set resource vme

set MAXmodule 24

set selectmodulemenu   {}
for {set i 1} {$i <= $MAXmodule} { incr i} {append  selectmodulemenu "$i "}
set modulelist $selectmodulemenu

for {set i 1} {$i <= $MAXmodule} { incr i} {set modulepresent($i) 0}


proc connect-MPX {} {
  global MPXPresent MPXServer
  
  if {$MPXPresent == 0} {return}

#    disconnect anything currently using the scope channels this uses

    set register /$MPXServer/MPX?.rlyA?
    set value 0
    catch {EG "register :pattern '$register' :value '$value'"}

    set register /$MPXServer/ISM.rlyA?
    set value 0
    catch {EG "register :pattern '$register' :value '$value'"}

#    setup the routing through the multiplexor module
#    the registers are created in /MIDAS/config/VME

#   enable analogue input 1 for scope channel 1

    set register /$MPXServer/MPX1.amux1
    set value 8
    catch {EG "register :name '$register' :value '$value'"}

#    connect scope channel 1 for analogue use

    set register /$MPXServer/MPX1.rlyA0
    set value 2
    catch {EG "register :name '$register' :value '$value'"}
    
#   enable analogue input 2 for scope channel 2

    set register /$MPXServer/MPX1.amux2
    set value 9
    catch {EG "register :name '$register' :value '$value'"}

#    connect scope channel 2 for analogue use

    set register /$MPXServer/MPX1.rlyA1
    set value 2
    catch {EG "register :name '$register' :value '$value'"}
}
