#    include file for the High Voltage control

lappend tasklist "hv		#"

lappend tasklist "hvtb		#"
lappend tasklist "hvqb		#"
lappend tasklist "hvcb		#"
lappend tasklist "hvib		#"
lappend tasklist "hvtg		#"
lappend tasklist "hvqg		#"
lappend tasklist "hvcg		#"
lappend tasklist "hves		#"
lappend tasklist "hvds		#"
lappend tasklist "hvwn		#"
lappend tasklist "hvmflecroy	#"
lappend tasklist "hvmfcaen	#"
lappend tasklist "hvsetup	#"
lappend tasklist "hvpos		#"
lappend tasklist "hvdbm		#"


set ACTION(HV) "HV \{inform hv start\}"

set MENU(HV)   ":button HV  :label \"High Voltage...\" :inactive F"



proc tkDarken {color percent} {

    foreach {red green blue} [winfo rgb . $color] {
	set red [expr {($red/256)*$percent/100}]
	set green [expr {($green/256)*$percent/100}]
	set blue [expr {($blue/256)*$percent/100}]
	break
    }
    if {$red > 255} {
	set red 255
    }
    if {$green > 255} {
	set green 255
    }
    if {$blue > 255} {
	set blue 255
    }
    return [format "#%02x%02x%02x" $red $green $blue]
}
